<template>
  <div>
    <v-tooltip bottom>
      <template v-slot:activator="{ on }">
        <v-btn fab small color="primary" @click.stop="dialog = true" v-on="on">
          <v-icon>settings</v-icon>
        </v-btn>
      </template>
      <span>Settings</span>
    </v-tooltip>

    <v-dialog v-model="dialog" width="800">
      <v-card>
        <v-container fluid>
          <v-layout fill-height>
            <v-flex xs6 class="pa-2">
              <v-layout column>
                <v-flex>
                  <p class="headline">Graph</p>
                  <vis-type-selector
                    :types="typesCharts"
                    labelText="Layout"
                    side="left"
                  ></vis-type-selector>
                </v-flex>
                <v-flex>
                  <v-subheader class="pl-0"
                    >(Only Radial Network) How many edges does a node need to
                    have before it's edges are drawn?</v-subheader
                  >
                  <v-slider
                    min="1"
                    :max="maxDegree"
                    value="degree"
                    thumb-label
                    @change="updateDegree"
                  ></v-slider>
                </v-flex>
                <v-flex>
                  <div align="center">
                    <v-btn color="primary" @click="updateEdgeDegree">
                      Apply
                    </v-btn>
                  </div>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex shrink>
              <v-divider vertical></v-divider>
            </v-flex>
            <v-flex xs6 class="pa-2">
              <p class="headline">Matrix</p>
              <vis-type-selector
                :types="typesReorderings"
                labelText="Ordering"
                side="right"
              ></vis-type-selector>
              <v-switch v-model="descending" label="Descending"></v-switch>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import VisTypeSelector from "@/components/VisTypeSelector.vue";
import { mapState } from "vuex";

export default {
  components: {
    VisTypeSelector
  },
  props: {
    typesCharts: Array,
    typesReorderings: Array
  },
  data() {
    return {
      dialog: false
    };
  },
  computed: {
    ...mapState(["degree"]),
    descending: {
      get() {
        return this.$store.state.descending;
      },
      set(value) {
        this.$store.commit("toggleDescending", value);
        this.$router.go();
      }
    }
  },
  methods: {
    updateEdgeDegree() {
      this.$store.commit("setDegree", this.internalDegree);
    },
    updateDegree(degree) {
      this.internalDegree = degree;
    }
  }
};
</script>

<style></style>
